




		#INCLUDE P16F877A.INC
		CBLOCK 20H
		WAIT0
		WAIT1
		WAIT2
		LCD_DATA
		ENDC

		#DEFINE E 1
		#DEFINE RS 2


		ORG 000
		GOTO INIT
INT

CLR_LCD	;write the lcd function clear the screen
		MOVLW B'00000001'
		CALL WRIT_FUNC	
		MOVLW .2
		CALL DELAYMS
		RETURN

_2ND_LINE ;set the lcd address to this latera value
		MOVLW .128 + .64
WRIT_FUNC ;write the lcd function in the working register
		MOVWF LCD_DATA
		MOVLW B'11110000'
		ANDWF LCD_DATA,W
		MOVWF PORTD
		BSF PORTE,E
		BCF PORTE,RS
		BCF PORTE,E
		CLRF PORTD
		SWAPF LCD_DATA
		MOVLW B'11110000'
		ANDWF LCD_DATA,W
		MOVWF PORTD
		BSF PORTE,E
		BCF PORTE,RS
		BCF PORTE,E
		CLRF PORTD
		MOVLW .50
		CALL DELAYUS
		RETURN

WRITE_DATA	;write the data in the working register to lcd screen
		MOVWF LCD_DATA
		MOVLW B'11110000'
		ANDWF LCD_DATA,W
		MOVWF PORTD
		BSF PORTE,E
		BSF PORTE,RS
		BCF PORTE,RS
		BCF PORTE,E
		SWAPF LCD_DATA
		MOVLW B'11110000'
		ANDWF LCD_DATA,W
		MOVWF PORTD
		BSF PORTE,E
		BSF PORTE,RS
		BCF PORTE,RS
		BCF PORTE,E
		CLRF PORTD
		MOVLW .50
		CALL DELAYUS
		RETURN

;**********************************
;INITIALIZATION OF REGISTERS*******
;**********************************
INIT
		CLRF PORTA
		CLRF PORTB

		BANKSEL TRISA
		MOVLW B'00000000'
		MOVWF TRISA
		MOVLW B'00000000'
		MOVWF TRISB
		MOVLW B'00000000'
		MOVWF TRISC
		MOVLW B'00000000'
		MOVWF TRISD
		MOVLW B'00000001'
		MOVWF TRISE
		MOVLW B'10000000'
		MOVWF OPTION_REG
		BANKSEL PORTA

	;setting the 4-bit lcd comm
		MOVLW B'00101000'
		MOVWF PORTD
		MOVLW .50
		BSF PORTE,E
		CALL DELAYUS
		BCF PORTE,E		

	;initialization of lcd module
		MOVLW B'00101000'
		CALL WRIT_FUNC
		MOVLW B'00101000'
		CALL WRIT_FUNC
		MOVLW B'00010100'
		CALL WRIT_FUNC
		MOVLW B'00001100'
		CALL WRIT_FUNC
		CALL CLR_LCD

	;preparing the data to write to lcd
		MOVLW 'I'
		CALL WRITE_DATA
		MOVLW 'p'
		CALL WRITE_DATA
		MOVLW 'i'
		CALL WRITE_DATA
		MOVLW 'n'
		CALL WRITE_DATA
		MOVLW 'i'
		CALL WRITE_DATA
		MOVLW 'm'
		CALL WRITE_DATA
		MOVLW 'o'
		CALL WRITE_DATA
		MOVLW ' '
		CALL WRITE_DATA
		MOVLW 'T'
		CALL WRITE_DATA
		MOVLW 'e'
		CALL WRITE_DATA
		MOVLW 'c'
		CALL WRITE_DATA
		MOVLW 'h'
		CALL WRITE_DATA
		MOVLW '.'
		CALL WRITE_DATA
		MOVLW ' '
		CALL WRITE_DATA
		MOVLW ' '
		CALL WRITE_DATA
		MOVLW ' '
		CALL WRITE_DATA

		CALL _2ND_LINE
		MOVLW ' '
		CALL WRITE_DATA
		MOVLW ' '
		CALL WRITE_DATA
		MOVLW ' '
		CALL WRITE_DATA
		MOVLW 'L'
		CALL WRITE_DATA
		MOVLW 'c'
		CALL WRITE_DATA
		MOVLW 'd'
		CALL WRITE_DATA
		MOVLW ' '
		CALL WRITE_DATA
		MOVLW 't'
		CALL WRITE_DATA
		MOVLW 'e'
		CALL WRITE_DATA
		MOVLW 's'
		CALL WRITE_DATA
		MOVLW 't'
		CALL WRITE_DATA

		NOP
		GOTO $-1











DELAYMS
		MOVWF WAIT2
		MOVLW .15
		MOVWF WAIT0
		MOVLW .109
		MOVWF WAIT1
		DECFSZ WAIT1
		GOTO $-1
		DECFSZ WAIT0
		GOTO $-5
		DECFSZ WAIT2
		GOTO $-9
		RETURN
DELAYUS
		MOVWF WAIT1
		MOVLW .10
		MOVWF WAIT0
		DECFSZ WAIT0
		GOTO $-1
		DECFSZ WAIT1
		GOTO $-5
		RETURN

		END

